diff -ruN uppsrc/Core/core.upt uppsrc/Core/core.upt
--- uppsrc/Core/core.upt	2011-11-06 07:29:10 +0400
+++ uppsrc/Core/core.upt	2012-07-01 08:55:57 +0400
@@ -16,21 +16,22 @@
 
 #endif
 @@<:PACKAGE:>.cpp
-#include <:?header:>"<:PACKAGE:>.h"<:/:><Core/Core.h><:.:>
+#include <:?header:>"<:PACKAGE:>.h"<:/:><Core/Core.h>
 
-<:?!header:>using namespace Upp;<:.:>
+using namespace Upp;<:.:>
 
 CONSOLE_APP_MAIN
-{
-	<:?cmdline:>const Vector<String>& cmdline = CommandLine();
+{<:?cmdline:>
+	const Vector<String>& cmdline = CommandLine();
 	for(int i = 0; i < cmdline.GetCount(); i++) {
 	}<:.:>
 }
 @@<:PACKAGE:>.upp
 uses Core;
 
-file <:?header:>"<:PACKAGE:>.h",<:.:>
-	"<:PACKAGE:>.cpp";
+file<:?header:>
+	<:PACKAGE:>.h,<:.:>
+	<:PACKAGE:>.cpp;
 
 mainconfig
 	"" = "<:?mt:>MT<:.:><:?mt && sse2:> <:.:><:?sse2:>SSE2<:.:>";
diff -ruN uppsrc/Core/sub.upt uppsrc/Core/sub.upt
--- uppsrc/Core/sub.upt	2011-11-06 07:29:10 +0400
+++ uppsrc/Core/sub.upt	2012-07-01 09:29:29 +0400
@@ -6,4 +6,5 @@
 
 #endif
 @@<:PACKAGE:>.upp
-file "<:PACKAGE:>.h";
+file
+	<:PACKAGE:>.h;
diff -ruN uppsrc/CtrlLib/Complex.upt uppsrc/CtrlLib/Complex.upt
--- uppsrc/CtrlLib/Complex.upt	2011-11-06 07:29:10 +0400
+++ uppsrc/CtrlLib/Complex.upt	2012-07-01 08:56:16 +0400
@@ -13,12 +13,12 @@
 
 #include <CtrlLib/CtrlLib.h>
 
-using namespace Upp;
+using namespace Upp;<:?lay:>
 
-<:?lay:>#define LAYOUTFILE <<:PACKAGE:>/<:PACKAGE:>.lay>
-#include <CtrlCore/lay.h><:.:>
+#define LAYOUTFILE <<:PACKAGE:>/<:PACKAGE:>.lay>
+#include <CtrlCore/lay.h><:.:><:?iml:>
 
-<:?iml:>#define IMAGEFILE <<:PACKAGE:>/<:PACKAGE:>.iml>
+#define IMAGEFILE <<:PACKAGE:>/<:PACKAGE:>.iml>
 #include <Draw/iml_header.h><:.:>
 
 class <:classname:> : public <:lay > 1 ? "With" + classname + "Layout<TopWindow>" : "TopWindow":> {
@@ -29,14 +29,14 @@
 
 #endif
 @@main.cpp
-#include "<:PACKAGE:>.h"
+#include "<:PACKAGE:>.h"<:?iml:>
 
-<:?iml:>#define IMAGEFILE <<:PACKAGE:>/<:PACKAGE:>.iml>
+#define IMAGEFILE <<:PACKAGE:>/<:PACKAGE:>.iml>
 #include <Draw/iml_source.h><:.:>
 
 <:classname:>::<:classname:>()
-{
-	<:?lay > 1:>CtrlLayout<:(lay == 3 ? "OKCancel" : ""):>(*this, "Window title");<:.:>
+{<:?lay > 1:>
+	CtrlLayout<:(lay == 3 ? "OKCancel" : ""):>(*this, "Window title");<:.:>
 }
 
 GUI_APP_MAIN
@@ -46,8 +46,8 @@
 @@<:PACKAGE:>.lay
 ??lay
 
-LAYOUT(<:classname:>Layout, 200, 100)
-	<:?lay == 3:>ITEM(Button, ok, SetLabel("OK").RightPosZ(90, 80).BottomPosZ(4, 22))
+LAYOUT(<:classname:>Layout, 200, 100)<:?lay == 3:>
+	ITEM(Button, ok, SetLabel("OK").RightPosZ(90, 80).BottomPosZ(4, 22))
 	ITEM(Button, cancel, SetLabel("Cancel").RightPosZ(4, 80).BottomPosZ(4, 22))<:.:>
 END_LAYOUT
 @@<:PACKAGE:>.iml
@@ -58,11 +58,10 @@
 	CtrlLib;
 
 file
-	"<:PACKAGE:>.h"
-	, main.cpp
-	<:?lay:>, "<:PACKAGE:>.lay"<:.:>
-	<:?iml:>, "<:PACKAGE:>.iml"<:.:>
-;
+	<:PACKAGE:>.h,
+	main.cpp<:?lay:>,
+	<:PACKAGE:>.lay<:.:><:?iml:>,
+	<:PACKAGE:>.iml<:.:>;
 
 mainconfig
 	"" = "GUI<:?mt:> MT<:.:><:?sse2:> SSE2<:.:>";
diff -ruN uppsrc/CtrlLib/Normal.upt uppsrc/CtrlLib/Normal.upt
--- uppsrc/CtrlLib/Normal.upt	2011-11-06 07:29:10 +0400
+++ uppsrc/CtrlLib/Normal.upt	2012-07-01 08:56:50 +0400
@@ -15,7 +15,9 @@
 
 #endif
 @@main.cpp
-#include <:?header:>"<:PACKAGE:>.h"<:/:><CtrlLib/CtrlLib.h><:.:>
+#include <:?header:>"<:PACKAGE:>.h"<:/:><CtrlLib/CtrlLib.h>
+
+using namespace Upp;<:.:>
 
 GUI_APP_MAIN
 {
@@ -24,9 +26,9 @@
 uses
 	CtrlLib;
 
-file
-	<:?header:>"<:PACKAGE:>.h",<:.:>
-	"main.cpp";
+file<:?header:>
+	<:PACKAGE:>.h,<:.:>
+	main.cpp;
 
 mainconfig
 	"" = "GUI<:?mt:> MT<:.:><:?sse2:> SSE2<:.:>";
diff -ruN uppsrc/upt/SDLCore.upt uppsrc/upt/SDLCore.upt
--- uppsrc/upt/SDLCore.upt	2011-11-06 07:29:15 +0400
+++ uppsrc/upt/SDLCore.upt	2012-07-01 09:04:37 +0400
@@ -21,8 +21,10 @@
 @@<:PACKAGE:>.cpp
 <:?header:>#include "<:PACKAGE:>.h"
 <:/:>#include <Core/Core.h>
-#include <plugin/SDL/SDL.h><:.:>
-<:?video:>
+#include <plugin/SDL/SDL.h>
+
+using namespace Upp;
+<:.:><:?video:>
 SDL_Surface * OpenScreen(const int width, const int height, const int bpp, const int flags)
 {
 	SDL_Surface * screen = SDL_SetVideoMode(width, height, bpp, flags);
@@ -89,11 +91,12 @@
 uses
 	Core;
 
-file <:?header:>"<:PACKAGE:>.h",<:.:>
-	"<:PACKAGE:>.cpp";
-
 library(MSC) "SDL SDLmain";
 library(GCC WIN32) "SDL.dll SDLmain";
 
+file<:?header:>
+	<:PACKAGE:>.h,<:.:>
+	<:PACKAGE:>.cpp;
+
 mainconfig
 	"" = "<:?sse2:>SSE2<:.:>";
diff -ruN uppsrc/upt/SDLPure.upt uppsrc/upt/SDLPure.upt
--- uppsrc/upt/SDLPure.upt	2011-11-06 07:29:15 +0400
+++ uppsrc/upt/SDLPure.upt	2012-07-01 09:04:55 +0400
@@ -82,11 +82,12 @@
 	return 0;
 }
 @@<:PACKAGE:>.upp
-file <:?header:>"<:PACKAGE:>.h",<:.:>
-	"<:PACKAGE:>.cpp";
-
 library(MSC) "SDL SDLmain";
 library(GCC WIN32) "SDL.dll SDLmain";
 
+file<:?header:>
+	<:PACKAGE:>.h,<:.:>
+	<:PACKAGE:>.cpp;
+
 mainconfig
 	"" = "<:?sse2:>SSE2<:.:>";
diff -ruN uppsrc/upt/Win32.upt uppsrc/upt/Win32.upt
--- uppsrc/upt/Win32.upt	2011-11-06 07:29:15 +0400
+++ uppsrc/upt/Win32.upt	2012-07-01 09:00:42 +0400
@@ -5,11 +5,11 @@
 option "Hello World" hello;
 option "Use SSE2" sse2 = 1;
 
-@@resource.h
-<:?icon:>#define IDI_BIG         100
-#define IDI_SMALL       101
-<:.:>
-<:?menu:>#define IDD_ABOUT       102
+@@resource.h<:?icon:>
+#define IDI_BIG         100
+#define IDI_SMALL       101<:.:><:?menu:>
+
+#define IDD_ABOUT       102
 #define IDM_ABOUT       103
 #define IDM_EXIT        104
 #define IDC_WIN32APP    105
@@ -17,14 +17,12 @@
 #define IDC_STATIC      -1<:.:>
 @@<:PACKAGE:>.rc
 #include "resource.h"
-#include <windows.h>
+#include <windows.h><:?icon:>
 
-<:?icon:>
 // Put your program icon into the package directory
 IDI_SMALL ICON DISCARDABLE "icon.ico"
-IDI_BIG   ICON DISCARDABLE "icon.ico"
-<:.:>
-<:?menu:>
+IDI_BIG   ICON DISCARDABLE "icon.ico"<:.:><:?menu:>
+
 IDC_WIN32APP MENU DISCARDABLE
 BEGIN
     POPUP "&File"
@@ -65,7 +63,7 @@
             return TRUE;
 
         case WM_COMMAND:
-            if(LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
+            if(LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
             {
                 EndDialog(hDlg, LOWORD(wParam));
                 return TRUE;
@@ -79,47 +77,46 @@
 {<:?menu:>
     int wmId, wmEvent;<:.:>
     PAINTSTRUCT ps;
-    HDC hdc;
-    <:?hello:>
+    HDC hdc;<:?hello:>
+
     const TCHAR szHello[] = "Hello World!";<:.:>
 
-    switch (message) 
+    switch (message)
     {<:?menu:>
         case WM_COMMAND:
-        
-            wmId    = LOWORD(wParam); 
-            wmEvent = HIWORD(wParam); 
+            wmId    = LOWORD(wParam);
+            wmEvent = HIWORD(wParam);
 
             switch(wmId)
             {
                 case IDM_ABOUT:
                    DialogBox(hInst, (LPCTSTR) IDD_ABOUT, hWnd, (DLGPROC) About);
                    break;
-                
+
                 case IDM_EXIT:
                    DestroyWindow(hWnd);
                    break;
-                   
+
                 default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
             }
             break;
-        <:.:>
+<:.:>
         case WM_PAINT:
             hdc = BeginPaint(hWnd, &ps);
-            
+
             /* Put your drawing code here */
-            <:?hello:>
-            RECT rt;
+            <:?hello:>RECT rt;
             GetClientRect(hWnd, &rt);
-            DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER | DT_VCENTER | DT_SINGLELINE);<:.:>
+            DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
+<:.:>
             EndPaint(hWnd, &ps);
             break;
-            
+
         case WM_DESTROY:
             PostQuitMessage(0);
             break;
-            
+
         default:
             return DefWindowProc(hWnd, message, wParam, lParam);
    }
@@ -131,7 +128,6 @@
                      LPSTR     lpCmdLine,
                      int       nCmdShow)
 {
-    
     WNDCLASSEX wcex;
 
     wcex.cbSize = sizeof(WNDCLASSEX); 
@@ -150,25 +146,25 @@
     wcex.lpszClassName  = "UPPW32APP";
 
     if(RegisterClassEx(&wcex) == 0)
-        return FALSE;
-    <:?menu:>   
-    hInst = hInstance;
-    <:.:>
+        return FALSE;<:?menu:>
+
+    hInst = hInstance;<:.:>
+
     HWND hWnd = CreateWindow(wcex.lpszClassName, "Ultimate application", WS_OVERLAPPEDWINDOW, 
                              CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 
                              NULL, NULL, hInstance, NULL);
     if(!hWnd)
         return FALSE;
-    
+
     ShowWindow(hWnd, nCmdShow);
-    UpdateWindow(hWnd);
-    <:?menu:>
+    UpdateWindow(hWnd);<:?menu:>
+
     HACCEL hAccelTable = LoadAccelerators(hInstance, (LPCTSTR) IDC_WIN32APP);
     <:.:>
     MSG msg;
     while(GetMessage(&msg, NULL, 0, 0))
     {<:?menu:>
-        if(!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
+        if(!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
         {
             TranslateMessage(&msg);
             DispatchMessage(&msg);
@@ -183,9 +179,10 @@
 @@<:PACKAGE:>.upp
 library(WIN32) "kernel32 user32 advapi32 shell32 winmm";
 
-file resource.h, 
-     <:PACKAGE:>.rc,
-     <:PACKAGE:>.cpp;
+file
+	resource.h,
+	<:PACKAGE:>.rc,
+	<:PACKAGE:>.cpp;
 
 mainconfig
     "" = "GUI<:?sse2:> SSE2<:.:>";